<template>
  <div>
    <q-badge
      :color="color"
      class="npk-badge"
      :class="{ 'npk-badge-dense': dense }"
    >
      <span v-html="elementDisplay" />
      <span class="q-ml-xs text-bold">{{ quantityDisplay }}</span>
    </q-badge>
    <div
      v-if="showAdditionalMinMaxDisplay"
      class="text-caption text-grey text-small text-center"
    >
      {{ minMaxDisplay }}
    </div>
  </div>
</template>

<script>
const P_TO_P2O5 = 2.2951
const K_TO_K2O = 1.2046

export default {
  name: 'NPKBadge',
  props: {
    elementId: {
      type: String,
      required: true,
      validator: x => ['n', 'p', 'k', 'ca', 'mg'].includes(x.toLowerCase())
    },
    quantity: {
      type: [Number, String],
      default: null
    },
    min: {
      type: [Number, String],
      default: null
    },
    max: {
      type: [Number, String],
      default: null
    },
    unit: {
      type: String,
      default: null
    },
    formulaId: {
      type: String,
      default: null
    },
    deemphasize: {
      type: Boolean,
      default: false
    },
    dense: {
      type: Boolean,
      defualt: false
    }
  },
  computed: {
    quantityValue () {
      return this.getConvertedValue(this.quantity)
    },
    minValue () {
      return this.getConvertedValue(this.min)
    },
    maxValue () {
      return this.getConvertedValue(this.max)
    },
    convertToP2O5 () {
      return this.displayPKAsOxyde && this.elementId?.toUpperCase() === 'P'
    },
    convertToK2O () {
      return this.displayPKAsOxyde && this.elementId?.toUpperCase() === 'K'
    },
    elementDisplay () {
      if (this.formulaId?.toUpperCase() === 'P2O5' || this.convertToP2O5) {
        return 'P<sub>2</sub>O<sub>5</sub>'
      } else if (this.formulaId?.toUpperCase() === 'K2O' || this.convertToK2O) {
        return 'K<sub>2</sub>O'
      } else {
        return `<span class="text-capitalize">${this.elementId.toLowerCase()}</span>`
      }
    },
    quantityDisplay () {
      let val
      if (this.quantityValue === null) {
        if (this.minValue !== null && this.maxValue !== null) {
          val = this.minMaxDisplay
        } else if (this.minValue !== null) {
          val = this.minDisplay
        } else if (this.maxValue !== null) {
          val = this.maxDisplay
        } else {
          return '-'
        }
      } else if (this.quantityValue === 0) {
        return '-'
      } else if (this.quantityValue > 0 && this.quantityValue < 0.1) {
        val = '< 0.1'
      } else {
        val = this.quantityValue.toFixed(1)
      }
      if (this.unit) {
        val += ' ' + this.unit
      }
      return val
    },
    minDisplay () {
      if (this.minValue !== null) {
        return `> ${this.minValue.toFixed(1)}`
      }
      return null
    },
    maxDisplay () {
      if (this.maxValue !== null) {
        return `< ${this.maxValue.toFixed(1)}`
      }
      return null
    },
    minMaxDisplay () {
      if (this.minValue !== null && this.maxValue !== null && this.minValue !== this.maxValue) {
        return `${this.minValue.toFixed(1)} - ${this.maxValue.toFixed(1)}`
      }
      return null
    },
    color () {
      if (this.deemphasize) {
        return 'blue-grey-5'
      } else {
        return `${this.elementId.toLowerCase()}-color`
      }
    },
    showAdditionalMinMaxDisplay () {
      return this.quantityValue !== null && this.minMaxDisplay !== null
    },
    displayPKAsOxyde () {
      return this.$store.state.appState.displayPKAsOxyde
    }
  },
  methods: {
    getConvertedValue (val) {
      if (val === null || val === undefined) {
        return null
      } else if (this.convertToP2O5) {
        return Number(val) * P_TO_P2O5
      } else if (this.convertToK2O) {
        return Number(val) * K_TO_K2O
      } else {
        return Number(val)
      }
    }
  }
}
</script>

<style scoped>
.npk-badge {
  font-size: 15px;
  padding: 5px;
  min-width: 80px;
  min-height: 27px;
  display: flex;
  flex-direction: row;
  justify-content: space-around;
}
.npk-badge.npk-badge-dense {
  min-width: 50px;
}
</style>
